#include <stdio.h>
#include <string.h>

#include <gsloop.h>
#include <gsloop_types.h>
#include <gsloop_con.h>

int _gsl_debuglevel = 100;


int gsloop_init(gsloop_t	*gsloop_anon,
		gsloop_attr_t	*attr)
{
	struct gsloop	*gsloop = (struct gsloop *)gsloop_anon;
	int		err;

	memset(gsloop, 0, sizeof(struct gsloop));

	memcpy(&gsloop->attr, attr, sizeof(struct gsloop_attr));

	err = rn_init(&gsloop->rn, gsloop->attr.max_fd);

	err = gsloop_con_init(gsloop);

	/* err = gsl_sig_init(); */

	return err;
}


int gsloop_destroy(gsloop_t	*gsloop_anon)
{
	struct gsloop	*gsloop = (struct gsloop *)gsloop_anon;
	int		i, err = 0;

	for (i = 0; i < gsloop->con_alloced; i++) {
		if (gsloop->con_list[i].common.fd != 0) {
			err = gsloop->con_list[i].common.close(gsloop, &gsloop->con_list[i]);
		}
	}

	return err;
}


int gsloop_dispatch(gsloop_t		*gsloop_anon,
		    unsigned int	timeout)
{
	struct gsloop	*gsloop = (struct gsloop *)gsloop_anon;
	int		err;

	err = rn_waitAndDispatchEvents(&gsloop->rn, timeout);

	return err;
}
